#include "gloobus-preview-interface-list.h"

// ========================= DESTRUCTOR =================================== //
iList::~iList()
{
	//gtk_widget_destroy  ( m_image );
	//gtk_widget_destroy  ( m_image_container );
	gdk_pixbuf_unref 	  ( m_pixbuf);
}
//============================= END =========================================== //
void iList::end()
{

}
// ========================= CONSTRUCTOR ================================= //
void iList::load()
{
	g_debug("\nLoading iList...\n");
	scale_image();
	
};

// =========================== GET SIZE (W)================================= //
int  iList::get_width()
{
	 	return 500;

};

// =========================== GET SIZE (H)================================= //
int  iList::get_height()
{
	
		return 500;
	
};

// =========================== DRAW IMAGE ================================= //
void iList::draw_list(GtkContainer * container)
{

	GtkWidget *m_image = gtk_image_new_from_pixbuf (m_pixbuf);
	GtkWidget *m_image_container = gtk_fixed_new ();
	int x = SHADOW_WIDTH;							//Default values are at top left
	int y = HEADER_HEIGHT + SHADOW_WIDTH;			//and 20 from top (For the header)

	if(gdk_pixbuf_get_width(m_pixbuf) < 300)		//Minum width
	{
		x = 150-gdk_pixbuf_get_width(m_pixbuf)/2;
	}
	if(gdk_pixbuf_get_height(m_pixbuf) < 300)		//Minium height
	{
		y = 150-gdk_pixbuf_get_height(m_pixbuf)/2;
	}


	gtk_fixed_put 	  (GTK_FIXED(m_image_container),m_image,x+10,y+7);
	gtk_container_add (GTK_CONTAINER(container),m_image_container);
	gtk_widget_show   (m_image_container);
	gtk_widget_show   (m_image);
	
	//======================================== FILE INFO ====================================//	
	
	iList::draw_file_info(container);
	
	//=========================================== LIST ======================================//
	
	GtkWidget *scwin = gtk_scrolled_window_new(NULL,NULL);
	gtk_scrolled_window_set_policy 		( GTK_SCROLLED_WINDOW(scwin) ,GTK_POLICY_AUTOMATIC ,GTK_POLICY_AUTOMATIC );
	gtk_scrolled_window_set_shadow_type ( GTK_SCROLLED_WINDOW(scwin),  GTK_SHADOW_IN);
	
	GtkWidget				*m_vBox  = gtk_vbox_new (true, 0);
	

	
	PangoAttrList* at = pango_attr_list_new();
	//pango_attr_list_insert(at,pango_attr_foreground_new(65000,65000,65000));
	pango_attr_list_insert(at,pango_attr_weight_new(PANGO_WEIGHT_SEMIBOLD));
	
	
	int n = get_n_items();
	
	for(int i=0; i< n ;i++)
	{
		GtkWidget *tempHBox  	= gtk_hbox_new (true, 0);

		for(int j=0; j< get_n_columns(); j++)
		{
		GtkWidget *tempAlig  	= gtk_alignment_new			(0,0.5,0,0);
		string 	   tempString   = get_item(i,j) + "             ";
		GtkWidget *tempLabel 	= gtk_label_new				( tempString.c_str() );

						  		  gtk_label_set_attributes	( GTK_LABEL(tempLabel)	,  at			);
						  		  gtk_container_add			( GTK_CONTAINER(tempAlig), tempLabel	);
						  		  gtk_container_add			( GTK_CONTAINER(tempHBox), tempAlig	    );
		}
		
  	   gtk_container_add			( GTK_CONTAINER(m_vBox)	,tempHBox 	);
  	   
	}

//	GtkWidget *alig  	= gtk_alignment_new			(0,0.5,0,0);
//	GtkWidget *label 	= gtk_label_new				("Filename1.pdf \t\t 32kb");
//						  gtk_label_set_attributes	( GTK_LABEL(label)		,at		);
//						  gtk_container_add			( GTK_CONTAINER(alig)	,label 	);
//						  gtk_container_add			( GTK_CONTAINER(m_vBox)	,alig 	);
//	
//	GtkWidget *alig2  	= gtk_alignment_new			(0,0.5,0,0);
//	GtkWidget *label2 	= gtk_label_new				("Filename2.pdf \t\t 40MB");
//						  gtk_label_set_attributes	( GTK_LABEL(label2)		,at		);
//						  gtk_container_add			( GTK_CONTAINER(alig2)	,label2	);
//						  gtk_container_add			( GTK_CONTAINER(m_vBox)	,alig2 	);
//	
//	GtkWidget *alig3  	= gtk_alignment_new			(0,0.5,0,0);
//	GtkWidget *label3 	= gtk_label_new				("Filename3.pdf \t\t 3GB");
//						  gtk_label_set_attributes	( GTK_LABEL(label3)		,at		);
//						  gtk_container_add			( GTK_CONTAINER(alig3)	,label3	);
//						  gtk_container_add			( GTK_CONTAINER(m_vBox)	,alig3 	);
	
	
	GtkWidget *mainAlig	= gtk_alignment_new			(0,0,0,0);
						  gtk_container_add			(GTK_CONTAINER(mainAlig),m_vBox);
						  
	gtk_scrolled_window_add_with_viewport ( GTK_SCROLLED_WINDOW( scwin ), mainAlig);
	gtk_widget_set_uposition	  	( scwin , 25 + SHADOW_WIDTH, 260 + SHADOW_WIDTH + HEADER_HEIGHT );
    gtk_widget_set_usize			( scwin , 450, 250);
    gtk_widget_show_all				( scwin  );  
  	gtk_container_add			   	( GTK_CONTAINER(container), scwin );
};

// ========================== SCALE IMAGE ================================= //
// Scale the image to the maxium size of max_x and max_y
// TODO: Configure these values by a config file
void iList::scale_image(int max_x, int max_y)
{
	g_debug("Scaling image...\n");
	GdkPixbuf 	*temp = get_pixbuf();				//Function Implemented by Plugin
	g_debug("Image Loaded\n");
	int x = gdk_pixbuf_get_width  (temp);
	int y = gdk_pixbuf_get_height (temp);

	//int min_x = 100;
	//int min_y = 100;
//	int max_x = 1200;
//	int max_y = 800;



	bool modify = false;
	double value;
	
	if(x > max_x)
	{
		value = max_x/float(x);
		x = x*value;
		y = y*value;
		modify=true;
	}	
	if(y > max_y)  
	{
		value = max_y/float(y);
		x = x*value;
		y = y*value;
		modify=true;
	}

	if(modify)
	{
		value = double(x)/(gdk_pixbuf_get_width(temp));

		g_debug("Scaling Image (%f):%dx%d",value,gdk_pixbuf_get_width(temp),gdk_pixbuf_get_height(temp));
		g_debug("--> %ix%i\n",x,y);
	}

	m_pixbuf  = gdk_pixbuf_scale_simple (temp,x,y,GDK_INTERP_BILINEAR);
}

// ========================= DRAW IMAGE INFO ===================== //
void iList::draw_file_info(GtkContainer * container)
{
	draw_properties ( container, get_file_info_string(), 285 + SHADOW_WIDTH,80 + SHADOW_WIDTH);
}

// ========================= DRAW ===================== //
// Virtual function that draws what plugin wants
void iList::draw( GtkContainer * container )
{
	draw_list		( GTK_CONTAINER(container ));
	draw_file_info	( GTK_CONTAINER(container ));
}
