#ifndef _GLOOBUSWIN_
#define _GLOOBUSWIN_


#include <gtk/gtk.h>
#include <string>
#include <cairo.h>
#include <config.h>

#include "gloobus-preview-defines.h"


// Class for creating a window, it creates a nice cairo window
// Not so customizable by parameters, just for creating the windows very quickly if I need more than one
// 

using namespace std;

class gloobusWin
{
	private:
		GtkWidget* 	m_window;			//window itself
		GtkWidget*	m_container;		//window container
		int			m_w;				//window width
		int			m_h;				//window height
		string		m_title;			//window title

	public:
		void 			create_window 			( int w, int h );				// Initializes and creates the window
		void		 	quit		     		( void );						// Quit (normal)
		static void 	quit2		     		( void ) { gtk_main_quit(); }	// Callback
		void			show_all				( void );						// Show all (Window widget)
		void			set_title				( string title );				// set window title
		void			set_size				( int w, int h);
		GtkWidget*		get_window_pointer 		( void );
		GtkWidget*		get_container_pointer 	( void );
		void			create_container		( void );
		void			add_common_buttons		( void );
		int 			get_width				( void );
		int 			get_height				( void );

		//Cairo Drawin functions		
		void 			draw_header	 		(cairo_t *cr, int x, int y, int w, int h, int r);
		void 			draw_background 	(cairo_t *cr, int x, int y, int w, int h, int r);
		void 			draw_bottom 		(cairo_t *cr, int x, int y, int w, int h, int r);
		void			draw_shadow			(cairo_t *cr, int x, int y, int w, int h, int r);
		void			draw_title			(cairo_t *cr, int w);
		
	private:
		void			add_close_button	( void );
		void			add_gloobus_button	( void );
		void			add_drag_button		( void );
		void			expose				( void );
		void			show_menu			( void );
		void			launch_menu_action	( gchar * label );

		// Another Callback
		static void trick	(GtkWidget *widget, GdkEventExpose *event, gpointer prInstance)						
		{
			gloobusWin * instance = (gloobusWin*)prInstance;
			instance->expose( );					
		}
		
		// Another Callback
		static void trick2	(GtkWidget *widget, GdkEventExpose *event, gpointer prInstance)						
		{
			gloobusWin * instance = (gloobusWin*)prInstance;
			instance->show_menu();				
		}

		// Another Callback
		static void trick3	(GtkWidget *widget, GdkEventExpose *event, gpointer prInstance)						
		{
			gloobusWin * instance = (gloobusWin*)prInstance;
			instance->launch_menu_action( (gchar*)gtk_menu_item_get_label(GTK_MENU_ITEM(widget)) );		
		}
};

#endif
