#include "plugin-ttf.h"


gboolean on_expose_event(GtkWidget *widget,  GdkEventExpose *event, gpointer* data)
{

	cairo_t *cr;

	//Create drawable
	cr = gdk_cairo_create(widget->window);
	
	//Clear background	//FIXME: It should be by default, not clrearing and drawing again
	cairo_set_source_rgba 	( cr, 0, 0, 0, 0.8);	
	cairo_set_operator    	( cr, CAIRO_OPERATOR_SOURCE );
	cairo_paint	  			( cr );

	//Set font and white for the text
	cairo_set_font_face		(cr, (cairo_font_face_t*)data);
	cairo_set_source_rgba 	(cr, 255, 255, 255, 1);

	//Get the scale
	cairo_text_extents_t extents;	
	cairo_text_extents   	(cr, "ABCDEFGHIJKLMNOPQRSTVWXYZ", &extents);

	//g_debug("TEXT W: %f, H: %f\n", extents.width, extents.height);
	float scale = 900/extents.width;

	cairo_matrix_t font_matrix;
	cairo_matrix_init_identity	(&font_matrix);
	cairo_matrix_scale			(&font_matrix, scale * 15,scale * 15);

	cairo_set_font_matrix	(cr,&font_matrix);
	cairo_move_to 			(cr, extents.width, 80);
	cairo_show_text 		(cr, "Font Preview");

	cairo_matrix_init_identity	(&font_matrix);
	cairo_matrix_scale			(&font_matrix, scale * 9,scale * 9);
	cairo_set_font_matrix		(cr,&font_matrix);

	cairo_move_to 			(cr, 0.0, 180);
	cairo_show_text 		(cr, "ABCDEFGHIJKLMNOPQRSTVWXYZ");
	cairo_move_to 			(cr, 0.0, 240);
	cairo_show_text 		(cr, "abcdefghijklmnopqrstvwxyz");
	cairo_move_to 			(cr, extents.width, 300);
	cairo_show_text 		(cr, "ÀÁàáÈÉèéÌÍìíÒÓòóÙÚùú");
	cairo_move_to 			(cr, extents.width*2, 360);
	cairo_show_text			(cr, "1234567890");

	cairo_matrix_init_identity	(&font_matrix);
	cairo_matrix_scale			(&font_matrix, scale *4,scale * 4);
	cairo_set_font_matrix		(cr,&font_matrix);

//	cairo_move_to 			(cr, 0.0, 480);
//	cairo_show_text 		(cr, "This Is An Example Text To See How This Typo Works Under A Some");
//	cairo_move_to 			(cr, 0.0, 500);
//	cairo_show_text 		(cr, "Larger Text. It has more than 50 letters.");
	cairo_move_to 			(cr, 0.0, 480);
	cairo_show_text 		(cr, "\"Computer science is as much about computers as astronomy ");
	cairo_move_to 			(cr, 0.0, 500);
	cairo_show_text 		(cr, "is about telescopes.\" - Edsgar Dijkstra");

	cairo_destroy(cr);

}

//================================================================== //


iTtf::iTtf(){}
iTtf::~iTtf()
{
	g_print("PLUGIN: iTtf Destroyed\n");
	//gst_object_unref (GST_OBJECT (m_pipeline));
}

// =============================== GET WIDTH ========================== //
int iTtf::get_width	( void )
{
	return 900;
}
// =============================== GET WIDTH ========================== //
int iTtf::get_height( void )
{
	return 550;
}

// ================================ LOAD ============================== //
void iTtf::draw_free( GtkContainer * container)
{

	load_font();
	GtkWidget *drawing_area = gtk_drawing_area_new    ();
							  gtk_drawing_area_size   (GTK_DRAWING_AREA(drawing_area),get_width() - SHADOW_WIDTH -20 ,get_height());

	g_signal_connect (G_OBJECT (drawing_area), "expose_event",
                      G_CALLBACK (on_expose_event), m_cairo_font);

	
	GtkWidget *fixed = gtk_fixed_new ();
	gtk_fixed_put		(GTK_FIXED(fixed),			drawing_area, SHADOW_WIDTH + 20 ,HEADER_HEIGHT + SHADOW_WIDTH + 20);
	gtk_container_add 	(GTK_CONTAINER(container),	fixed);
	gtk_widget_show  	(GTK_WIDGET(fixed));
	gtk_widget_show	  	(drawing_area);
	

	g_print("iTTF: draw free\n");
}



// ========================== LOAD FONT ================================ //
void iTtf::load_font	(void)
{
	
	FT_Library library; 
	FT_Init_FreeType( &library );
	FT_Face face; 

	FT_New_Face( library, m_filename.c_str(), 0, &face ); 
	m_cairo_font = cairo_ft_font_face_create_for_ft_face(face,0);


}





